unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, DB, StdCtrls, ADODB, xmldom,
  XMLIntf, msxmldom, XMLDoc, XPMan,
  GRDDelphi;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    GroupBox1: TGroupBox;
    BtnFindName: TButton;
    EditFindName: TEdit;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    ADOTable1: TADOTable;
    ADODataSet1: TADODataSet;
    GroupBox2: TGroupBox;
    EditFindTel: TEdit;
    BtnFindTel: TButton;
    GroupBox3: TGroupBox;
    EditFilterAddress: TEdit;
    BtnFilterEnabled: TButton;
    BtnFilterDisabled: TButton;
    EditFilterName: TEdit;
    LabelFilterName: TLabel;
    LabelFilterAddress: TLabel;
    EditFilterTel: TEdit;
    LabelFilterTel: TLabel;
    XMLDocument1: TXMLDocument;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnFindNameClick(Sender: TObject);
    procedure BtnFindTelClick(Sender: TObject);
    procedure BtnFilterEnabledClick(Sender: TObject);
    procedure BtnFilterDisabledClick(Sender: TObject);
    procedure UpdateFilter;
    procedure EditFilterNameChange(Sender: TObject);
    procedure EditFilterAddressChange(Sender: TObject);
    procedure EditFilterTelChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

  {       Guardant }
const
   CryptPU:      DWORD=$8566783;							{   }
   CryptRD:      DWORD=$7d49c84;							{   }

var
  BDPath, BDNew, BDAdmin, BDPassword : String; //     

  //       
  ClientID : LongInt;
  ClientName : String;

  //     Guardant API
  nRet:  integer;			        {  .       }
  hGrd:HANDLE;                {   Guardant API }

  //     Guardant
  dwPublic:     DWORD;				{     }
  dwPrivRD:     DWORD;				{     }

  //  ,      
  GrdFindInfo1, GrdFindInfo2 : TGrdFindInfo;

  //           
  dwRemoteMode:         DWORD;					      { /  }
  dwFlags:              DWORD;							  {    }
  byProg:               Byte;								  {   }
  byVer:                Byte;									{  }
  dwID:                 DWORD;								{ ID  }
  wSN:                  Word;									{   }
  wMask:                Word;						      {   }
  wType:                Word;						      {   }
  dwModel:              DWORD;				        {   }
  dwInterface:          DWORD;			          {   : LPT, USB }

  //   
  donglefindcount:      integer;

//    
  ReadData: array[0..52] of Char;

{----------------------------------------------------------------------------------------------}
{     Guardant API                                                       }

{ :    Guardant                                                             }
{	:                                                                              }
{	:                                                                             }
{--------------------------------------------------------------------------------------------- }
function ErrorHandling(hGrd:HANDLE;nRet:integer):integer;
var
    ErrorMsg:Array[1..5000] of Char;	{      }

begin
{        .     }
{ 1.         . }
{ 2.      ,   ,   .}

{   ,       }

  	  if( nRet <> GrdE_OK ) Then //   
	      begin
            //      Guardant     (      )
            GrdFormatMessage(hGrd,nRet,GrdLng_RUS,@ErrorMsg[1],5000,nil );
            MessageBox(0,@ErrorMsg, '',0);

           	if( hGrd <> nil )	Then //   ,      Guardant API
            begin
              //     
              GrdLogout(hGrd, 0);
              //  ,  
              GrdCloseHandle( hGrd );
            end;
            //   Guardant API
            GrdCleanup();
            ErrorHandling:=nRet;
            ExitProcess(0);exit;
	      end;
	    ErrorHandling:=nRet;
end;


// ------------------------------------------------------
//    .   .
// -------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
 var
 i : Integer;
begin
//    
 if Not(FileExists('config.xml')) then
  Begin
   ShowMessage('   ');
   Form1.Close; exit;
  End;

//      
 XMLDocument1.LoadFromFile('config.xml');
 XMLDocument1.Active := true;
 BDPath := XMLDocument1.DocumentElement.ChildNodes['DBPath'].Text;
 BDAdmin := XMLDocument1.DocumentElement.ChildNodes['DBAdmin'].Text;
 BDPassword := XMLDocument1.DocumentElement.ChildNodes['DBPassword'].Text;
//    
 if (BDPath[2] <> ':') then
   BDPath:= GetCurrentDir + '\' + BDPath;

 if Not(FileExists(BDPath)) then
  Begin
   ShowMessage('    ');
   Form1.Close;
  End;

//     ADO
 BDNew := 'Provider=Microsoft.Jet.OLEDB.4.0;' +
          'Data Source=' + BDPath + ';' +
          'User ID='+BDAdmin+'; Password='+BDPassword+';'+
          'Mode=Share Deny None;Extended Properties="";' +
          'Jet OLEDB:Engine Type=5;';

 ADOConnection1.ConnectionString := BDNew;

 //     
   ADODataSet1.Connection := ADOConnection1;
   ADODataSet1.CommandText := 'select * from ClientsList';
   ADODataSet1.Open;

//    
  DBGrid1.Fields[0].DisplayWidth := 5;
  For i:=1 to DBGrid1.FieldCount-1 do DBGrid1.Fields[i].DisplayWidth := 25;

  {-----------   Guardant API --------}

//  Guardant API
  nRet := GrdStartupEx(GrdFMR_Local, nil, nil);
  ErrorHandling(nil,nRet); {    }

//    Guardant API
  hGrd := GrdCreateHandle(nil, GrdCHM_MultiThread,  nil );
  ErrorHandling(hGrd,nRet);

  //      
  dwPublic:= GrdDC_DEMONVK-CryptPU;				{      }
  dwPrivRD:= GrdDC_DEMORDO-CryptRD;				{      }

  //      (   )
  nRet:= GrdSetAccessCodes(hGrd,   dwPublic + CryptPU,  dwPrivRD + CryptRD, 0, 0 );
  ErrorHandling(hGrd,nRet);

  {$IFDEF Debug}
  //          ID
  nRet:= GrdFind(hGrd,  GrdF_First, @dwID, @GrdFindInfo1);
  //    
//  if ( nRet = GrdE_OK )
  donglefindcount := 0;

  while( nRet = GrdE_OK ) do
	    begin
        ShowMessage ('ID = '+IntToStr(dwID));
        inc(donglefindcount);
        //   
		    nRet:= GrdFind( hGrd, GrdF_Next , @dwID, @GrdFindInfo2 );
	    end;

    if( nRet = GrdE_AllDonglesFound )	then{      }
        ShowMessage ('  ')
	  else
		  ErrorHandling(hGrd,nRet);

     if (donglefindcount=0) then //     
     begin
         {    }
         ShowMessage('   .');
         Form1.Close; exit;
     end
      else //     1  
     begin
      //          GrdFindInfo1
      ShowMessage(
        '     : '   + chr(10)+chr(13)+
        'ID  = ' + IntToStr(GrdFindInfo1.dwID) + chr(10)+chr(13)+
        '  = 0x'+ IntToHex(GrdFindInfo1.dwPublicCode,8) + chr(10)+chr(13)+
        '  = ' + IntToStr(GrdFindInfo1.byHrwVersion)  + chr(10)+chr(13)+
        '   () = ' + IntToStr(GrdFindInfo1.byMaxNetRes) + chr(10)+chr(13)+
        '  = ' + IntToHex(GrdFindInfo1.wType,4) + chr(10)+chr(13)+
        '  = ' + IntToStr(GrdFindInfo1.byNProg) + chr(10)+chr(13)+
        '  = ' + IntToStr(GrdFindInfo1.byVer) + chr(10)+chr(13)+
        '  = ' + IntToStr(GrdFindInfo1.wSN) + chr(10)+chr(13)+
        '   = ' + IntToStr( GrdFindInfo1.wMask)+ chr(10)+chr(13)+
        '  = ' + IntToStr( GrdFindInfo1.wGP)+ chr(10)+chr(13)+
        '   =  ' + IntToStr( GrdFindInfo1.wRealNetRes)+ chr(10)+chr(13)+
        ' = ' + IntToStr( GrdFindInfo1.dwIndex)
    );
    end;
    {$ENDIF}  

//    
    dwRemoteMode:= GrdFMR_Local;	{    }
    dwFlags:= GrdFM_NProg + GrdFM_Mask;     	{       }
    dwID:=   0;	                  { ID .   }
    byProg:= 5; 	                {     }
    wSN:=    0;	                  {  .      }
    byVer:=  0;                   { .     }
    wMask:=  77;                   {   }
    dwModel:= GrdFMM_ALL;         {   }
    dwInterface:= GrdFMI_ALL;     {    }
    nRet := GrdSetFindMode(hGrd,  dwRemoteMode, dwFlags, byProg, dwID, wSN, byVer, wMask, wType, dwModel, dwInterface );


    //     (    GrdFindMode).
    //     Guardant API,    GrdCloseHandle()/GrdLogin()    
    nRet:= GrdLogin(hGrd,  $0FFFFFFFF, GrdLM_PerStation );
    ErrorHandling(hGrd,nRet);
  {-----------   Guardant API --------}
end;

// ------------------------------------------------------
//   .   .
// -------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ADODataSet1.Close;
  ADOConnection1.Close;

  {-----------   Guardant API --------}
	if( hGrd <> nil )	Then //   ,      Guardant API
    begin
      //     
      nRet := GrdLogout(hGrd, 0);
      //  ,  
      nRet:= GrdCloseHandle( hGrd );
    end;
  //   Guardant API
  nRet:= GrdCleanup();

  {-----------   Guardant API --------}
end;

procedure TForm1.BtnFindNameClick(Sender: TObject);
begin
//   ,        ,   
  if (Length(trim(EditFindName.Text))=0) then exit;

  {-----------   Guardant API --------}
  {$IFDEF Debug}
    {        }
    nRet:= GrdRead(hGrd,             { }
                   24,              {      }
                   52,               {    }
                   @ReadData[0],     {  ,     }
                   nil);             {}
    ErrorHandling(hGrd,nRet);        { }

    {    SAM}
	  nRet:= GrdSetWorkMode(hGrd,       { }
                          GrdWM_SAM,  {  }
                          GrdWMFM_DriverAuto);  {   }
    ErrorHandling(hGrd,nRet);

    {   ID }
    nRet:= GrdRead(hGrd,             { }
                   GrdSAM_dwID,      {   }
                   4,   {   }
                   @ReadData[0],          {  }
                   nil);             {}
    ErrorHandling(hGrd,nRet);        { }

   dwID := ord(ReadData[0])+ ord(ReadData[1])*256 + ord(ReadData[2])*65536 + ord(ReadData[3])*16777216;
   ShowMessage(' : '+IntToStr(dwID) );

    {$ENDIF}
  {-----------   Guardant API --------}

//    
 if not ADODataSet1.Locate('ClientName',EditFindName.Text,[loPartialKey]) then
  ShowMessage('    '+EditFindName.Text + '  ');
end;

//     
procedure TForm1.BtnFindTelClick(Sender: TObject);
var
 TempStr : String;
begin
//   ,        ,   
  if (Length(trim(EditFindTel.Text))=0) then exit;
{
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      !    .       .
                ,
         ,      . ,    
        ,   ,         .
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
}

 {-----------   Guardant API --------}
//        .
//       "lesson1.nsd", 
//     GrdUtil.exe
//          3  

//   
	  nRet:= GrdPI_Read(hGrd,			                {   Guardant }
			                00,	 			                {    }
			                0,												{         }
			                32,	 			{     }
			                @ReadData[0],						  {       }
			                1469608341,		            {       }
			                nil );										{ ,   nil }

//       .  .
    if (nRet = GrdE_InactiveItem) then
      Begin //  .   
     	  {     }
          nRet:= GrdPI_Activate(hGrd,											{   Guardant}
			                    00,					                    {      }
			                    408956937 );	{       }
          ErrorHandling(hGrd,nRet);

        {    ,      }
    	    nRet:= GrdPI_Read(hGrd,			          {   Guardant }
			                00,	 			                {    }
			                0,												{         }
			                32,	 			              {     }
			                @ReadData[0],						  {       }
			                1469608341,		            {       }
			                nil );										{ ,   nil }

        {     }
        ErrorHandling(hGrd,nRet);

      //      
        TempStr := String(ReadData);

     //       'HelloWord!',  ,      
        if (TempStr <> 'HelloWord!') then
        begin
          MessageDlg(' ', mtError, [mbOk], 0);
          Form1.Close;exit;
        end;

      End  //  .   
     else
      Begin //  .   
         ErrorHandling(hGrd,nRet); {       }

        //      
          TempStr := String(ReadData);
       //       'HelloWord!',  ,      
        if (TempStr = 'HelloWord!') then
        begin
          MessageDlg(' ', mtError, [mbOk], 0);
          Form1.Close;exit;
        end;

        //     
        ClientID := ord(ReadData[3])+ ord(ReadData[2])*256 + ord(ReadData[1])*65536 + ord(ReadData[0])*16777216;
        TempStr := ADODataSet1.Lookup('ClientID',ClientID,'ClientName');

        if  (TempStr = NULL) then //      ,    
        Begin
          MessageDlg(' ', mtError, [mbOk], 0);
          Form1.Close;exit;
        End
         else //  
        Begin
          //      28,  
          if (Length(ClientName)>28) then ClientName := copy(ClientName,1,28);
          if (copy(ReadData,3,Length(ClientName)) <> ClientName) then
          Begin
            MessageDlg(' ', mtError, [mbOk], 0);
            Form1.Close;exit;
          End;
       End;
       End; //  .   

       {      ,       .}
       AdoDataSet1.Last;
       ClientID := StrToInt(AdoDataSet1.FieldByName('ClientID').AsString);
       ClientName := AdoDataSet1.FieldByName('ClientName').AsString;


        { ID     }
        ReadData[3] := chr(ClientID mod 256); ClientID := ClientID div 256;
        ReadData[2] := chr(ClientID mod 256); ClientID := ClientID div 256;
        ReadData[1] := chr(ClientID mod 256); ClientID := ClientID div 256;
        ReadData[0] := chr(ClientID);

        {     .  ClientID}
        nRet:= GrdPI_Update(hGrd,		   	{   }
			                        00,					{      }
			                        0,				  {    }
			                        4,					{     }
			                        @ReadData[0],	{      }
			                        843783688,	{   ,    0 }
			                        GrdUM_MOV,	{   }
			                        nil );			{  }
        ErrorHandling(hGrd,nRet);



         //    28   #0
        ClientName := ClientName+StringOfChar(chr(0),28-Length(ClientName));
	      {     .  ClientName }
        nRet:= GrdPI_Update(hGrd,		   	{   }
			                        00,					{      }
			                        4,				  {    }
			                        28,					{     }
			                        @ClientName[1],	{      }
			                        843783688,	{   ,    0 }
			                        GrdUM_MOV,	{   }
			                        nil );			{  }
        ErrorHandling(hGrd,nRet);

  {-----------   Guardant API --------}

 {    }
 if not ADODataSet1.Locate('ClientTelNumber',EditFindTel.Text,[loPartialKey]) then
  ShowMessage('    '+EditFindTel.Text + '  ');
end;

procedure TForm1.BtnFilterEnabledClick(Sender: TObject);
begin
//    
  BtnFilterEnabled.Enabled := False;
  BtnFilterDisabled.Enabled := True;
//  
  AdoDataSet1.Filtered := True;
//  
  UpdateFilter;
end;


procedure TForm1.BtnFilterDisabledClick(Sender: TObject);
begin
// .   
  BtnFilterEnabled.Enabled := True;
  BtnFilterDisabled.Enabled := False;
//  
  AdoDataSet1.Filtered := False;
end;

procedure TForm1.UpdateFilter;
Var
 StrFilter: String;
begin
//   
  StrFilter := '';
  if EditFilterName.Text <> '' then
      StrFilter := '(ClientName like %'+EditFilterName.Text+'%) AND ';
  if EditFilterAddress.Text <> '' then
      StrFilter := StrFilter +'(ClientAddress like %'+EditFilterAddress.Text+'%) AND ';
  if EditFilterTel.Text <> '' then
      StrFilter := StrFilter + '(ClientTel like %'+EditFilterTel.Text+'%) AND ';

  if (StrFilter <> '') then StrFilter := Copy(StrFilter,1,Length(StrFilter)-5);

  AdoDataSet1.Filter := StrFilter;
end;



procedure TForm1.EditFilterNameChange(Sender: TObject);
begin
  UpdateFilter;  //  
end;

procedure TForm1.EditFilterAddressChange(Sender: TObject);
begin
  UpdateFilter; //  
end;

procedure TForm1.EditFilterTelChange(Sender: TObject);
begin
  UpdateFilter;   //  
end;

end.



