unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, DB, StdCtrls, ADODB, xmldom,
  XMLIntf, msxmldom, XMLDoc, XPMan,
  GRDDelphi;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    GroupBox1: TGroupBox;
    BtnFindName: TButton;
    EditFindName: TEdit;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    ADOTable1: TADOTable;
    ADODataSet1: TADODataSet;
    GroupBox2: TGroupBox;
    EditFindTel: TEdit;
    BtnFindTel: TButton;
    GroupBox3: TGroupBox;
    EditFilterAddress: TEdit;
    BtnFilterEnabled: TButton;
    BtnFilterDisabled: TButton;
    EditFilterName: TEdit;
    LabelFilterName: TLabel;
    LabelFilterAddress: TLabel;
    EditFilterTel: TEdit;
    LabelFilterTel: TLabel;
    XMLDocument1: TXMLDocument;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnFindNameClick(Sender: TObject);
    procedure BtnFindTelClick(Sender: TObject);
    procedure BtnFilterEnabledClick(Sender: TObject);
    procedure BtnFilterDisabledClick(Sender: TObject);
    procedure UpdateFilter;
    procedure EditFilterNameChange(Sender: TObject);
    procedure EditFilterAddressChange(Sender: TObject);
    procedure EditFilterTelChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

  {       Guardant }
const
   CryptPU:      DWORD=$8566783;							{   }
   CryptRD:      DWORD=$7d49c84;							{   }

var
  BDPath, BDNew, BDAdmin, BDPassword : String; //     

{----------------------------------------------------------------------------------------------}
{     Guardant API                                                       }

{ :    Guardant                                                             }
{	:                                                                              }
{	:                                                                             }
{--------------------------------------------------------------------------------------------- }
function ErrorHandling(hGrd:HANDLE;nRet:integer):integer;
var
    ErrorMsg:Array[1..5000] of Char;	{      }

begin
{        .     }
{ 1.         . }
{ 2.      ,   ,   .}

{   ,       }

  	  if( nRet <> GrdE_OK ) Then //   
	      begin
            //      Guardant     (      )
            GrdFormatMessage(hGrd,nRet,GrdLng_RUS,@ErrorMsg[1],5000,nil );
            MessageBox(0,@ErrorMsg, '',0);

           	if( hGrd <> nil )	Then //   ,      Guardant API
            begin
              //     
              GrdLogout(hGrd, 0);
              //  ,  
              GrdCloseHandle( hGrd );
            end;
            //   Guardant API
            GrdCleanup();
            ErrorHandling:=nRet;
            ExitProcess(0);exit;
	      end;
        ErrorHandling:=nRet;
end;


// ------------------------------------------------------
//    .   .
// -------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
 var
 i : Integer;
begin
//    
 if Not(FileExists('config.xml')) then
  Begin
   ShowMessage('   ');
   Form1.Close; exit;
  End;

//      
 XMLDocument1.LoadFromFile('config.xml');
 XMLDocument1.Active := true;
 BDPath := XMLDocument1.DocumentElement.ChildNodes['DBPath'].Text;
 BDAdmin := XMLDocument1.DocumentElement.ChildNodes['DBAdmin'].Text;
 BDPassword := XMLDocument1.DocumentElement.ChildNodes['DBPassword'].Text;
//    
 if (BDPath[2] <> ':') then
   BDPath:= GetCurrentDir + '\' + BDPath;

 if Not(FileExists(BDPath)) then
  Begin
   ShowMessage('    ');
   Form1.Close;
  End;

//     ADO
 BDNew := 'Provider=Microsoft.Jet.OLEDB.4.0;' +
          'Data Source=' + BDPath + ';' +
          'User ID='+BDAdmin+'; Password='+BDPassword+';'+
          'Mode=Share Deny None;Extended Properties="";' +
          'Jet OLEDB:Engine Type=5;';

 ADOConnection1.ConnectionString := BDNew;

 //     
   ADODataSet1.Connection := ADOConnection1;
   ADODataSet1.CommandText := 'select * from ClientsList';
   ADODataSet1.Open;

//    
  DBGrid1.Fields[0].DisplayWidth := 5;
  For i:=1 to DBGrid1.FieldCount-1 do DBGrid1.Fields[i].DisplayWidth := 25;
end;

// ------------------------------------------------------
//   .   .
// -------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 //   ,  
 if ADOConnection1.Connected then
 Begin
  ADODataSet1.Close;
  ADOConnection1.Close;
 End;
end;

procedure TForm1.BtnFindNameClick(Sender: TObject);
begin
//   ,        ,   
  if (Length(trim(EditFindName.Text))=0) then exit;


//    
 if not ADODataSet1.Locate('ClientName',EditFindName.Text,[loPartialKey]) then
  ShowMessage('    '+EditFindName.Text + '  ');
end;

//     
procedure TForm1.BtnFindTelClick(Sender: TObject);
begin
//   ,        ,   
  if (Length(trim(EditFindTel.Text))=0) then exit;

 {    }
 if not ADODataSet1.Locate('ClientTelNumber',EditFindTel.Text,[loPartialKey]) then
  ShowMessage('    '+EditFindTel.Text + '  ');
end;

procedure TForm1.BtnFilterEnabledClick(Sender: TObject);
begin
//    
  BtnFilterEnabled.Enabled := False;
  BtnFilterDisabled.Enabled := True;
//  
  AdoDataSet1.Filtered := True;
//  
  UpdateFilter;
end;


procedure TForm1.BtnFilterDisabledClick(Sender: TObject);
begin
// .   
  BtnFilterEnabled.Enabled := True;
  BtnFilterDisabled.Enabled := False;
//  
  AdoDataSet1.Filtered := False;
end;

procedure TForm1.UpdateFilter;
Var
 StrFilter: String;
begin
//   
  StrFilter := '';
  if EditFilterName.Text <> '' then
      StrFilter := '(ClientName like %'+EditFilterName.Text+'%) AND ';
  if EditFilterAddress.Text <> '' then
      StrFilter := StrFilter +'(ClientAddress like %'+EditFilterAddress.Text+'%) AND ';
  if EditFilterTel.Text <> '' then
      StrFilter := StrFilter + '(ClientTel like %'+EditFilterTel.Text+'%) AND ';

  if (StrFilter <> '') then StrFilter := Copy(StrFilter,1,Length(StrFilter)-5);

  AdoDataSet1.Filter := StrFilter;
end;



procedure TForm1.EditFilterNameChange(Sender: TObject);
begin
  UpdateFilter;  //  
end;

procedure TForm1.EditFilterAddressChange(Sender: TObject);
begin
  UpdateFilter; //  
end;

procedure TForm1.EditFilterTelChange(Sender: TObject);
begin
  UpdateFilter;   //  
end;

end.



