using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml.Serialization;
using System.Data.OleDb;
using System.Threading; // Используем потоки
using Guardant; // Используем классы Guardant
using System.Security.Cryptography; // Используем Microsoft CryptoAPI

namespace Clients
{
    public partial class Form1 : Form
    {
        private config Config;
        private string connectionString;
        private bool lFilter;
        public AESBase AESBaseM;
        public Thread TProtectThread;
        
        /* Начало. Блок переменных для работы с Guardant API */ 
        GrdE RetCode;                       // Код ошибки для всех функций Guardant API
        Handle GrdHandle = new Handle();    // Создает пустой хэндл для контейнера Guardant

        static uint CryptPU = 0x8566783U;         // Константы для шифрования кодов
        static uint CryptRD = 0x17d49c84U;        // доступа к ключу защиты
        static long InitVector = 327235620;       // Вектор инициализации для алгоритма GSII64


        // Шифруем демонстрационные коды доступа, вычитая из них случайные числа для 
        // обеспечения более высокой степени взломоучтойчивости
        // This way they are not shown in the application
        uint PublicCode = (uint)GrdDC.DEMONVK - CryptPU;    // Должно быть зашифровано        
        uint ReadCode = (uint)GrdDC.DEMORDO - CryptRD;    // Должно быть зашифровано
        
        // Переменные используются в функции GrdSetFindMode()
        GrdFMR RemoteMode;         // Флаги поиска локальных или сетевых ключей                  
        GrdFM DongleFlags;        // Флаги поиска ключа                  
        uint ProgramNumber = 0;  // Номер программы                      
        uint Version = 0;        // Версия программы                                 
        uint DongleID = 0;       // ID ключа (Номер ключа)
//        uint ModelID = 0;        // Модель ключа
        byte[] TypeID = new byte[2];// Тип ключа
        uint SerialNumber;       // Сериный номер                           
        uint BitMask;            // Битовая маска                           
        GrdDT DongleType;         // Тип ключа                            
        GrdFMM DongleModel;        // Модель ключа                           
        GrdFMI DongleInterface;    // Тип интерфейса ключа

        FindInfo GrdFindInfo1 = new FindInfo();   // структура используемая в функции GrdFind()
        FindInfo GrdFindInfo2 = new FindInfo();   // структура используемая в функции GrdFind()

        byte[] DataForSign = new byte[20];					        // Данные для подписи
        // Результат подписи на алгоритме ECC160 
        byte[] ECCSign = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

/*
        // Массив содержащий незашифрованный публичный ключ алгоритма ECC160
        byte[] ECCPublicKey =
            {0x6B, 0x0C, 0xCB, 0xED, 0x30, 0xC7, 0x8B, 0x04, 0x36, 0x63,
            0x99, 0x66, 0x02, 0xA9, 0x16, 0x3A, 0xFB, 0x52, 0x4B, 0x7A,
	        0x85, 0xA1, 0xF3, 0xF3, 0x88, 0xF7, 0x2B, 0x3D, 0xDD, 0xE1,
            0x8D, 0x98, 0x40, 0xD9, 0x69, 0x66, 0x35, 0xF8, 0x8E, 0x64
        };
*/
        // Массив содержащий зашифрованный публичный ключ алгоритма ECC160
        byte[] ECCPublicKey =
        {0x47, 0xFA, 0x26, 0x2D, 0xE1, 0x14, 0x79, 0x0D, 0x18, 0x44, 
         0xD3, 0xEA, 0xBC, 0x8D, 0x22, 0xDB, 0xDF, 0x26, 0x51, 0xBD, 
         0x73, 0x6C, 0xDC, 0x86, 0x4F, 0x45, 0x47, 0xA3, 0x34, 0xEB, 
         0xE4, 0xFC, 0xA0, 0x8F, 0xC3, 0x42, 0x1E, 0x2D, 0x53, 0x2E
        };

        byte[] InitVectorAES;       // Переменная вектора инициализации для алгоритма AES
        byte[] DataPassword = new byte[32];
        byte[] GrdAES_Context = new byte[(int)GrdAES.CONTEXT_SIZE];

        // переменные для GrdWrite() и GrdRead()
        UInt32 TempDataID;              // Временные данные
        Byte[] TempData = new Byte[52]; // Временные данные для работы с функцией GrdRead
        Byte[] PIData = new Byte[32];   // Переменная для работы с защищенным ячейками

        /* Конец. Блок переменных для работы с Guardant API */

        int ClientID; // Хранится ID клиента из БД
        string ClientName; // Хранится имя клиента из БД

        // Криптопровайдер для инициализации функций Microsoft CryptoAPI
        RNGCryptoServiceProvider rngCsp;

        public Form1()
        {
            InitializeComponent();
            // Инициализация криптопровайдера Microsoft CryptoAPI
            rngCsp = new RNGCryptoServiceProvider();

            AESBaseM = new AESBase();

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            /* ----------- Начало блока работы с Guardant API ------------------ */

            // Инициализация копии GrdAPI. GrdStartup() должен быть вызван перед первым вызовом функций GrdAPI 
            RetCode = GrdApi.GrdStartup(GrdFMR.Local);	// Мы будем использовать только локальные ключи
            ErrorHandling(GrdHandle, RetCode);

            // -----------------------------------------------------------------
            // Создание контейнера Guardant и получение его хэндла
            // -----------------------------------------------------------------
            GrdHandle = GrdApi.GrdCreateHandle(GrdCHM.MultiThread);
            if (GrdHandle.Address == 0) // Если найдена ошибка
            {
                ErrorHandling(new Handle(0), GrdE.MemoryAllocation);
            }

            // -----------------------------------------------------------------
            // Установка кодов доступа к ключу защиты Guardant
            // -----------------------------------------------------------------
            RetCode = GrdApi.GrdSetAccessCodes(GrdHandle,	// хэндл контейнера Guardant 
                PublicCode + CryptPU,   // Публичный код. Используется для поиска ключа. Должен быть установлен
                ReadCode + CryptRD,     // Приватный код для чтения; Данный код используется для чтения незащищенных ячеек памяти;
                0,	// Приватный код для записи. В большинстве случаев, он не нужен. Старайтесь не включать его в итоговые версии приложения.
                0);  // Мастер код. Используется для редактирования параметров ключа. Никогда не вставляйте этот код в публичные версии приложения!

            ErrorHandling(GrdHandle, RetCode); // Обработка ошибок


            // -----------------------------------------------------------------
            // Устанавливаем параметры поиска ключа
            // -----------------------------------------------------------------
            RemoteMode = GrdFMR.Local; 				            // Поиск только локальных ключей
            DongleFlags = GrdFM.NProg & GrdFM.Mask;	            // Устанавливаем флаг поиска по номеру программы и маске
            ProgramNumber = 5;     								// Устанавливаем номер программы. В нашем поиске не используется.                
            DongleID = 0;       		     					// ID ключа. Не используется
            SerialNumber = 0;     							    // Серийный номер. В нашем поиске не используется.                     
            Version = 0;    									// Версия. В нашем поиске не используется                   
            BitMask = 77;     									// Битовая маска. В нашем поиске не используется.                    
            DongleType = GrdDT.GSII64;				            // Ключ с поддержкой алгоритма GSII64 
            DongleModel = GrdFMM.ALL;					        // Все модели ключей. 
            DongleInterface = GrdFMI.ALL;		   		        // Интерфейс подключения любой (LPT или USB)

            // Устанавливаем параметры поиска ключей защиты.
            // Все последующие запуски функций GrdFind() и GrdLogin() перед следующий изменением параметров, функцией 
            // GrdSetFindMode() будут использовать установленные критерии поиска.
            // Если значения полей ключа и заданные не совпадут, то выдастся ошибка.
            RetCode = GrdApi.GrdSetFindMode(GrdHandle,
                                            RemoteMode,
                                            DongleFlags,
                                            ProgramNumber,
                                            DongleID,
                                            SerialNumber,
                                            Version,
                                            BitMask,
                                            DongleType,
                                            DongleModel,
                                            DongleInterface);
            ErrorHandling(GrdHandle, RetCode);

            /* Устанавливаем режим условной компиляции, данный код в итоговое приложение вставлен не будет */
#if (DEBUG)

            int donglefindcount = 0;
            // -----------------------------------------------------------------
            // Поиск всех ключей и вывод их ID
            // -----------------------------------------------------------------
            RetCode = GrdApi.GrdFind(GrdHandle, GrdF.First, out DongleID, out GrdFindInfo1);
            while (RetCode == GrdE.OK)
            {
                // Увеличиваем счетчик ключей на 1
                donglefindcount++;
                // Выводим ID всех ключей
                MessageBox.Show("ID " + Convert.ToString(donglefindcount) + "-го ключа: " + Convert.ToString(DongleID), "Поиск ключей");
                // Поиск следующего ключа
                RetCode = GrdApi.GrdFind(GrdHandle, GrdF.Next, out DongleID, out GrdFindInfo2);
            }
            if (RetCode == GrdE.AllDonglesFound)						// Поиск завершен?
                MessageBox.Show("Поиск ключей завершен");
            else
                ErrorHandling(GrdHandle, RetCode);

            if (donglefindcount == 0)
            { // Если ни один ключ не найден, выводим ошибку и закрываем программу
                MessageBox.Show("Ни одного ключа защиты Guardant не найдено", "Поиск ключей");
                Application.Exit(); // Завершаем программу
            }
            else
            {   // Выводим подробную информацию о первом найденном ключе из структуры GrdFindInfo1
                MessageBox.Show(
                    "Подробная информация о первом найденном ключе: " + (char)10 + (char)13 +
                    "ID ключа = " + Convert.ToString(GrdFindInfo1.dwID) + (char)10 + (char)13 +
                    "Публичный код = 0x" + GrdFindInfo1.dwPublicCode.ToString("X") + (char)10 + (char)13 +
                    "Версия прошивки = " + Convert.ToString(GrdFindInfo1.byHrwVersion) + (char)10 + (char)13 +
                    "Ресурс сетевого ключа (макс) = " + Convert.ToString(GrdFindInfo1.byMaxNetRes) + (char)10 + (char)13 +
                    "Тип ключа = " + GrdFindInfo1.wType.ToString("X") + (char)10 + (char)13 +
                    "Номер программы = " + Convert.ToString(GrdFindInfo1.byNProg) + (char)10 + (char)13 +
                    "Версия программы = " + Convert.ToString(GrdFindInfo1.byVer) + (char)10 + (char)13 +
                    "Серийный номер = " + Convert.ToString(GrdFindInfo1.wSN) + (char)10 + (char)13 +
                    "Битовая маска  = " + Convert.ToString(GrdFindInfo1.wMask) + (char)10 + (char)13 +
                    "Счетчик  = " + Convert.ToString(GrdFindInfo1.wGP) + (char)10 + (char)13 +
                    "Реальный сетевой ресурс =  " + Convert.ToString(GrdFindInfo1.wRealNetRes) + (char)10 + (char)13 +
                    "Индекс = " + Convert.ToString(GrdFindInfo1.dwIndex)
                , "Информация о ключе");
            }

#endif // конец блока условной компиляции

            // Производим подключение к ключу (с параметрами поиска заданными GrdFindMode).
            // Все последующие вызовы функций Guardant API, до следующего вызова GrdCloseHandle()/GrdLogin()
            // будут использовать подключенный ключ
            RetCode = GrdApi.GrdLogin(GrdHandle, 0xFFFFFFFF, GrdLM.PerStation);
            ErrorHandling(GrdHandle, RetCode);

            /* ----------- Конец блока работы с Guardant API ------------------ */


            // Если файл конфигурации существует
            if (File.Exists("config.xml"))
            {
                try
                {
                    // Если файл настроек обнаружен пытаемся с ним работать через сериалайзер
                    Config = new config();
                    XmlSerializer serializer = new XmlSerializer(typeof(config));
                    TextReader reader = new StreamReader("config.xml");
                    Config = (config)serializer.Deserialize(reader);
                    reader.Close();

                    // Декодируем строку из BASE64 в byte
                    byte[] DBPathByte = DecodeFrom64(Config.DBPath);

                    /* ----------- Начало блока работы с Guardant API ------------------ */
                    // Дешифруем строку с использованием алгоритма GSII64
                    RetCode = GrdApi.GrdCrypt(GrdHandle,    // Хэндл контейнера Guardant
                                01,                         // Номер аппаратного алгоритма
                                DBPathByte,                 // Массив с путем к БД
                                (uint)GrdAM.OFB | (uint)GrdAM.Decode,   // Методы декодирования
                                InitVector);	            // Вектор инициализации
                    ErrorHandling(GrdHandle, RetCode);
                    /* ----------- Начало блока работы с Guardant API ------------------ */

                    // Получаем путь в string из массива байт
                    string DBPath = ByteToStr(DBPathByte);
                    
                    // из считанных настроек формируем строку соединения с БД
                    connectionString = "provider=Microsoft.Jet.OLEDB.4.0;data source=" + DBPath;
                    

                }
                catch
                {
                    return;
                }
            }
            else
            {
                // Создаем и вызываем диалог выборов параметров подключения
                ConnectToDatabase СTDForm = new ConnectToDatabase();
                DialogResult res = СTDForm.ShowDialog();


                // Если строка пути к файлу БД пустая, то завершаем работу приложения
                if (СTDForm.TBFileName.Text == "") 
                {
                    Application.Exit();
                }

                /* ----------- Начало блока работы с Guardant API ------------------ */
                // Преобразуем Путь к БД из string в byte
                byte[] DBPathByte = StrToByte(СTDForm.TBFileName.Text);

                // Шифруем строку с использованием алгоритма GSII64
                RetCode = GrdApi.GrdCrypt(GrdHandle,    // Хэндл контейнера Guardant
                            01,                         // Номер аппаратного алгоритма
                            DBPathByte,                 // Массив с путем к БД
                            (UInt32)GrdAM.OFB + (UInt32)GrdAM.Encode,   // Методы кодирования
                            InitVector);	            // Вектор инициализации
                ErrorHandling(GrdHandle, RetCode);
                /* ----------- Начало блока работы с Guardant API ------------------ */

                // если файла настроек нет, то формируем парамерты по умолчанию
                // и записываем их в файл настроек для дальнейшего использования
                // запись через сериалайзер
                Config = new config();
                Config.DBPath = EncodeTo64(DBPathByte); // Преобразуем путь к БД в base64
                Config.DBAdmin = СTDForm.TBUserName.Text;
                Config.DBPassword = СTDForm.TBPassword.Text;
                XmlSerializer serializer = new XmlSerializer(typeof(config));
                TextWriter writer = new StreamWriter("config.xml");
                serializer.Serialize(writer, Config);
                writer.Close();
                connectionString = "provider=Microsoft.Jet.OLEDB.4.0;data source=" + СTDForm.TBFileName.Text;

            }
            /* ----------- Начало блока работы с Guardant API ------------------ */

/*
            // Шифруем строку с использованием алгоритма GSII64
            RetCode = GrdApi.GrdCrypt(GrdHandle,    // Хэндл контейнера Guardant
                        01,                         // Номер аппаратного алгоритма
                        ECCPublicKey,               // Переменная с публичным ключом
                        (UInt32)GrdAM.OFB + (UInt32)GrdAM.Encode,   // Методы декодирования
                        InitVector);	            // Вектор инициализации
            TBFindName.Text = ByteArrayToHexString(ECCPublicKey);            
            
*/

            // Дешифруем строку с использованием алгоритма GSII64
            RetCode = GrdApi.GrdCrypt(GrdHandle,    // Хэндл контейнера Guardant
                        01,                         // Номер аппаратного алгоритма
                        ECCPublicKey,               // Переменная с публичным ключом
                        (UInt32)GrdAM.OFB + (UInt32)GrdAM.Decode,   // Методы декодирования
                        InitVector);	            // Вектор инициализации

            // Проверяем на возможные ошибки
            ErrorHandling(GrdHandle, RetCode);
            /* ----------- Начало блока работы с Guardant API ------------------ */

            // Запускаем дополнительный поток, для организации дополнительных проверок защиты
            TProtectThread = new Thread(ProtectThread);
            TProtectThread.IsBackground = true;
            TProtectThread.Start();
            
            // Загрузка таблицы
            // перед загрузкой сбрасываем признак установленного фильтра
            lFilter = false;
            this.reloadTable();
        }

        private void reloadTable()
        {
            // чистим таблицу
            this.dataGridView1.Rows.Clear();
            // созадем подключение и открываем его
            OleDbConnection conn = new OleDbConnection(this.connectionString);
            conn.Open();
            // строка выбора всех полей из таблицы
            string command = "select * from [ClientsList]";
            if (lFilter)
            {
                // если взведен признак фильтра, то формируем ту часть запроса
                // которая отвечает за условие отбора
                // при этом используется команда LIKE, которая позволяет делать сравнение на вхождение по маске
                string cName, cPhone, cAddress;
                bool lNoWhere = false;
                cName = this.textBox3.Text;
                cPhone = this.textBox5.Text;
                cAddress = this.textBox4.Text;
                if (cName.Length > 0)
                {
                    lNoWhere = true;
                    // на всякий случай заменяем одинарные кавычки на двойные, а знак процента на двойной процент - это необходимо чтобы не завалить БД
                    // ЗЫ: это один из способов ломануть сайт, построенный на субд, если программист забыл это предусмотреть
                    command += " where [ClientName] like '%" + cName.Replace("'", "\"").Replace("%", "%%") + "%'";
                }

                if (cPhone.Length > 0)
                {

                    if (!lNoWhere)
                    {
                        command += " where ";
                        lNoWhere = true;
                    }
                    else
                        command += " and ";

                    command += "[ClientTelNumber] like '%" + cPhone.Replace("'", "\"").Replace("%", "%%") + "%'";
                }

                if (cAddress.Length > 0)
                {
                    if (!lNoWhere)
                    {
                        command += " where ";
                        lNoWhere = true;
                    }
                    else
                        command += " and ";

                    command += "[ClientAddress] like '%" + cAddress.Replace("'", "\"").Replace("%", "%%") + "%'";
                }
            }
            // создаем класс запроса
            OleDbCommand cmd = new OleDbCommand(command, conn);
            // выполняем запрос с получение объекта результирующей таблицы
            OleDbDataReader myOleDbDataReader = cmd.ExecuteReader();
            int nRow;
            // пока таблица дает строки работает цикл
            while (myOleDbDataReader.Read())
            {
                // добавляем строку и заполняем колонки
                nRow = this.dataGridView1.Rows.Add();
                this.dataGridView1.Rows[nRow].Cells["ColumnID"].Value = Convert.ToInt32(myOleDbDataReader["ClientID"].ToString());
                this.dataGridView1.Rows[nRow].Cells["ColumnName"].Value = myOleDbDataReader["ClientName"].ToString();
                this.dataGridView1.Rows[nRow].Cells["ColumnAddress"].Value = myOleDbDataReader["ClientAddress"].ToString();
                this.dataGridView1.Rows[nRow].Cells["ColumnPhone"].Value = myOleDbDataReader["ClientTelNumber"].ToString();
                //this.dataGridView1.Rows[nRow].Cells["ColumnComment"].Value = myOleDbDataReader["ClientComments"].ToString();
                this.dataGridView1.Rows[nRow].Cells["ColumnCity"].Value = myOleDbDataReader["ClientCity"].ToString();
                // Здесь будет расшифровывание записи
                string VarCommentsDeCrypt = myOleDbDataReader["ClientComments"].ToString();
                this.dataGridView1.Rows[nRow].Cells["CommentsDeCrypt"].Value = VarCommentsDeCrypt;

            }
            // закрываем открытые подключения
            myOleDbDataReader.Close();
            conn.Close();
            // включаем или выключаем кнопки на панели инструментов
            bindingNavigatorAddNewItem.Enabled = true;
            if (dataGridView1.Rows.Count > 0)
            {
                bindingNavigatorMoveFirstItem.Enabled = true;
                bindingNavigatorMovePreviousItem.Enabled = true;
                bindingNavigatorMoveNextItem.Enabled = true;
                bindingNavigatorMoveLastItem.Enabled = true;
                bindingNavigatorDeleteItem.Enabled = true;
                dataGridView1.Rows[0].Selected = true;
            }
            else
            {
                bindingNavigatorMoveFirstItem.Enabled = false;
                bindingNavigatorMovePreviousItem.Enabled = false;
                bindingNavigatorMoveNextItem.Enabled = false;
                bindingNavigatorMoveLastItem.Enabled = false;
                bindingNavigatorDeleteItem.Enabled = false;
            }
        }


        private void bindingNavigatorMoveFirstItem_Click(object sender, EventArgs e)
        {
            // переход на первую строку таблицы
            dataGridView1.CurrentCell = dataGridView1.Rows[0].Cells[dataGridView1.CurrentCell.ColumnIndex];
        }

        private void bindingNavigatorMovePreviousItem_Click(object sender, EventArgs e)
        {
            // переход на предыдущую строку таблицы
            if (dataGridView1.CurrentRow.Index > 0)
            {
                dataGridView1.CurrentCell = dataGridView1.Rows[dataGridView1.CurrentRow.Index - 1].Cells[dataGridView1.CurrentCell.ColumnIndex];
            }
        }

        private void bindingNavigatorMoveNextItem_Click(object sender, EventArgs e)
        {
            // переход на следующую строку таблицы
            if (dataGridView1.CurrentRow.Index < dataGridView1.Rows.Count-1)
            {
                dataGridView1.CurrentCell = dataGridView1.Rows[dataGridView1.CurrentRow.Index + 1].Cells[dataGridView1.CurrentCell.ColumnIndex];
            }
        }

        private void bindingNavigatorMoveLastItem_Click(object sender, EventArgs e)
        {
            // переход на последнюю строку таблицы
            dataGridView1.CurrentCell = dataGridView1.Rows[dataGridView1.Rows.Count - 1].Cells[dataGridView1.CurrentCell.ColumnIndex];
        }

        private void bindingNavigatorAddNewItem_Click(object sender, EventArgs e)
        {
            // ----------------- Добавление новой записи ------------------------
            // Создаем и открываем форму добавления новой записи
            InsertToDB InsertForm = new InsertToDB();
            DialogResult res = InsertForm.ShowDialog();
           
            // Если нажата кнопка "Добавить"
            if (InsertForm.PushBtnAdd)
            {
                /* ----------- Начало блока защиты  ------------------ */
                // Получаем зашифрованное название города
                byte[] CityCrypt = AESBaseM.CityBase[InsertForm.CBClientTel_Code.Text];

                // Вектор инициализации алгоритма AES, создан из непечатаемых сиволов для 
                // затруднения его поиска в коде программы 
                InitVectorAES = new byte[] { 10, 245, 177, 6, 33, 21, 5, 53, 88, 192, 18, 32, 44, 223, 55, 11 };

                // Дешифруем название города на однонаправленном алгоритме AES 
                RetCode = GrdApi.GrdCrypt(GrdHandle,		    // Хэндл контейнера Guardant
                            06,				            // Номер аппаратнного алгоритма
                            CityCrypt,					// Данные для расшифровки
                            (UInt32)GrdAM.Decrypt +
                            (UInt32)GrdAM.CBC, 			// Дешифровать все блоки по методу CBC
                            InitVectorAES,			    // Вектор инициализации
                            DataPassword,					// Только для программно-реализованных алгоритмов
                            GrdAES_Context);			        // Только для программно-реализованных алгоритмов

                // Простая проверка без использования стандартных функций
                if (RetCode != GrdE.OK) 
                {
                    RetCode = GrdApi.GrdLogout(GrdHandle); // Отключаемся от ключа защиты
                    if (GrdHandle.Address != 0)	// Проверяем существует ли хэндл контейнера Guardant 
                    {
                        RetCode = GrdApi.GrdCloseHandle(GrdHandle); // Закрываем хэндл, выходим с сервера ключа,  освобождаем память
                    }
                    RetCode = GrdApi.GrdCleanup(); // Деинициализация копии Guardant API. Метод GrdCleanup() обязательно должен быть вызван перед закрытием программы
                    // Завершаем работу приложения
                    Environment.Exit((int)RetCode);
                }
                // Проверка на корректное завершение функции. В случае, если функция
                // выполнилась корректно, произойдет исключительная ситуация - деление на ноль,
                // именно это мы и обрабатываем }
                Random fixRand = new Random(DateTime.Now.Millisecond);
                try
                {
                    double TempDouble = fixRand.Next(416) / (int)RetCode;
                }
                // Если произошло деление на ноль, выполняем необходимые действия
                catch (DivideByZeroException divide_err)
                {
                    // Получаем расшифрованную строку в Win-2151
                    string CityDecrypt = Encoding.GetEncoding(1251).GetString(CityCrypt).Trim();
                    // Подключаемся к БД
                    OleDbConnection conn = new OleDbConnection(this.connectionString);
                    conn.Open();
                    // Вставляем данные в БД
                    string command = "INSERT INTO [ClientsList] ([ClientName], [ClientAddress], [ClientTelNumber], [ClientCity], [ClientComments]) "+
                        "VALUES ('" + InsertForm.TBClientName.Text + "', '" + InsertForm.TBClientAddress.Text + "' ,'" + InsertForm.TBClientTel_Prefix.Text + " (" + InsertForm.CBClientTel_Code.Text + ") " + InsertForm.TBClientTel_fix.Text + "', '" +
                        CityDecrypt + "' ,'" + InsertForm.TBClientComments.Text + "')";
                    OleDbCommand cmd = new OleDbCommand(command, conn);
                    OleDbDataReader myOleDbDataReader = cmd.ExecuteReader();
                    conn.Close();                 // Закрываем соединение с БД
                    this.reloadTable();           // Обновляем таблицу
                }

                /* ----------- Конец блока защиты  ------------------ */
            }

        }

        private void bindingNavigatorDeleteItem_Click(object sender, EventArgs e)
        {

            /* ----------- Начало блока защиты  ------------------ */

            // Создаем переменную, в котороую будут помещены случайные числа
            byte[] randomNumber = new byte[4];
            // Заполняем массив случайными числами с помощью Microsoft CryptoAPI
            rngCsp.GetBytes(randomNumber);
            // Берем случайное число 
            uint CryptoRND32 = BitConverter.ToUInt32(randomNumber, 0);
            // Получаем номер ячейки от 0 до 999
            uint aespos = CryptoRND32 % 1000;
            // Берем зашифрованное значение из ячейки
            byte[] aes1000c =  AESBaseM.aes1000crypt[aespos];


            // Вектор инициализации алгоритма AES 
            InitVectorAES = new byte[] { 14, 215, 77, 46, 93, 121, 115, 253, 28, 91, 28, 139, 214, 203, 135, 93 };

            // Дешифруем случайную строку на однонаправленном алгоритме AES 
            RetCode = GrdApi.GrdCrypt(GrdHandle,    // Хэндл контейнера Guardant
                        06,				            // Номер аппаратнного алгоритма
                        aes1000c,					// Данные для расшифровки
                        (UInt32)GrdAM.Decrypt +
                        (UInt32)GrdAM.CBC, 			// Дешифровать все блоки по методу CBC
                        InitVectorAES,			    // Вектор инициализации
                        DataPassword,				// Только для программно-реализованных алгоритмов
                        GrdAES_Context);	        // Только для программно-реализованных алгоритмов

            // Если функция выполнилась с ошибкой, то окно программы с экрана пропадает
            // Так же возможно организовать скрытие каких-то элементов формы
            Form1.ActiveForm.Top = Form1.ActiveForm.Top + 2641 * (int)RetCode;

            // удаление записи
            OleDbConnection conn = new OleDbConnection(this.connectionString);
            conn.Open();
            string idc = this.dataGridView1.CurrentRow.Cells[0].Value.ToString();
            string command = "delete from [ClientsList] where ([ClientID] = " + idc + "AND 0=" + (int)RetCode + " AND '" + BitConverter.ToString(aes1000c) + "'='" + BitConverter.ToString(AESBaseM.aes1000source[aespos]) + "')";

            /* ----------- Конец блока защиты  ------------------ */  
            OleDbCommand cmd = new OleDbCommand(command, conn);
            if (cmd.ExecuteNonQuery() > 0)
            {
                // если команда отработала, то удаляем из таблицы текущую запись
                dataGridView1.Rows.Remove(dataGridView1.CurrentRow);
            }
            conn.Close();
            // если удалена последняя запись, то нужно выключить кнопки на панели инструментов
            if (dataGridView1.Rows.Count == 0)
            {
                bindingNavigatorMoveFirstItem.Enabled = false;
                bindingNavigatorMovePreviousItem.Enabled = false;
                bindingNavigatorMoveNextItem.Enabled = false;
                bindingNavigatorMoveLastItem.Enabled = false;
                bindingNavigatorDeleteItem.Enabled = false;
            }
        }
        // ______________ Выключение фильтра __________________________
        private void BtnDisableFilter_Click(object sender, EventArgs e)
        {
            //----------- Начало блока защиты -------- //

            // Получаем случайное число с помощью Guardant API
            byte[] GrdRand = new byte[8];
            RetCode = GrdApi.GrdCrypt(
	                    GrdHandle,  // Хэндл контейнера Guardant
	                    02,         // Номер аппаратного алгоритма
	                    GrdRand ,   // Переменная в которую будет помещена случайная последовательность
	                    0,          // Не используется. Должно быть 0
	                    0);      // Не используется. Должно быть 0

            // Проверяем результат на возможные ошибки
            ErrorHandling(GrdHandle, RetCode); 
            
            // Проверяем попало ли случайное число в диапазон (примерно) 20%
            if (GrdRand[1] < 51)  // Если попало, то проверяем ЭЦП
            {

                // С помощью Guardant API проверяем был ли до этого вызван алгоритм цифровой подписи,
                // Для этого получаем CRC от подписи, т.к. в начале там находятся "0", то и CRC = 0
                if (GrdApi.GrdCRC(ECCSign   // Переменная содержащая ЭЦП
                            )              
                  != 0) 
                 { // Если проверка CRC пройдена
                  
                    // Проверяем электронно-цифровую подпись
                     RetCode = GrdApi.GrdVerifySign(
                                     GrdHandle,             // Хэндл контейнера Guardant
                                     (uint)GrdVSC.ECC160,   // Тип алгоритма ECC160
                                     (int)GrdECC160.PUBLIC_KEY_SIZE, // Длина публичного ключа (40 байт)
                                     ECCPublicKey,          // Переменная с публичным ключом
                                     20,                    // Длина подписанных данных 
                                     DataForSign,           // Переменная содержащая данные для подписи
                                     40,                    // Длина ЭЦП
                                     ECCSign);              // Переменная содержащая ЭЦП
                     // Проверяем результат на возможные ошибки
                     ErrorHandling(GrdHandle, RetCode); 

                    // Создаем неверную электронно-цифровую подпись
                     for (int i=0; i < 40; i++) { ECCSign[i] = Convert.ToByte(255 - ECCSign[i]); }

                     // Проверяем НЕВЕРНУЮ электронно-цифровую подпись
                     RetCode = GrdApi.GrdVerifySign(
                                     GrdHandle,             // Хэндл контейнера Guardant
                                     (uint)GrdVSC.ECC160,   // Тип алгоритма ECC160
                                     (int)GrdECC160.PUBLIC_KEY_SIZE, // Длина публичного ключа (40 байт)
                                     ECCPublicKey,          // Переменная с публичным ключом
                                     20,                    // Длина подписанных данных 
                                     DataForSign,           // Переменная содержащая данные для подписи
                                     40,                    // Длина ЭЦП
                                     ECCSign);              // Переменная содержащая ЭЦП

                    // Если возвращенный результат откличается от "Неверная цифровая подпись"
                    if (RetCode != GrdE.InvalidDigitalSign) 
                    {
                      // Если операция не вернула код ошибки, то это похоже на взлом, выводим 
                      // постороннюю ошибку CRC, чтобы сбить с толку потенциального взломщика
                       if (RetCode == GrdE.OK) RetCode = GrdE.CRCError;
                       ErrorHandling(GrdHandle, RetCode); 
                    }

                    // Возвращаем ЭЦП прежний вид
                    for (int i=0; i < 40; i++) ECCSign[i] = Convert.ToByte(255 - ECCSign[i]);

                 } // Конец проверки CRC
            } // Конец блока диапазона 20%


            //----------- Конец блока защиты -------- //
            // выключаем фильтр
            lFilter = false;
            this.BtnDisableFilter.Enabled = false;
            this.BtnEnableFilter.Enabled = true;
            this.reloadTable();
        }

        // ______________ Включение фильтра __________________________
        private void BtnEnableFilter_Click(object sender, EventArgs e)
        {
            
            //----------- Начало блока защиты -------- //
            
            // Подключаемся к БД
            OleDbConnection conn = new OleDbConnection(this.connectionString);
            conn.Open();
            // получаем максимальную код идентификатора
            string command = "select Max(ClientID) from [ClientsList]";
            OleDbCommand cmd = new OleDbCommand(command, conn);
            OleDbDataReader myOleDbDataReader = cmd.ExecuteReader();

            int nMax;
            // если таблица не пустая, то берем максимум
            if (myOleDbDataReader.Read())
                nMax = int.Parse(myOleDbDataReader[0].ToString());
            else
            // если таблица пустая, то 0
                nMax = 0;
            // закрываем табличку
            myOleDbDataReader.Close();
            
            
            // Создаем переменную, в котороую будут помещены случайные числа
            byte[] randomNumber = new byte[4];
            // Заполняем массив случайными числами
            rngCsp.GetBytes(randomNumber);

            // Берем часть случайного числа для вычисления вероятности
            int CryptoRND16 = BitConverter.ToInt16(randomNumber, 2);
            // Берем полное случайное число для получения записи из БД
            uint CryptoRND32 = BitConverter.ToUInt32(randomNumber, 0);

            // Проверяем вероятность 20% (от 65535) и таблицу на наличие записей
            if ((CryptoRND16 < 13107) && (nMax != 0)) 
            {
                // получаем случайную запись из БД
                cmd.CommandText = "select top 1 [ClientName] from [ClientsList] where [ClientID]>" + Convert.ToString(CryptoRND32 % nMax);
                myOleDbDataReader = cmd.ExecuteReader();

                string nClientName = "";
                // Получаем имя случайного клиента
                if (myOleDbDataReader.Read())
                    nClientName = myOleDbDataReader[0].ToString();
                // закрываем табличку
                myOleDbDataReader.Close();
                
                // Т.е. функция вычисления цифровой подписи работает с данными длинной 20 байт, 
                // нужно имя случайного клиента обрезать или добавить до этой длины
                
                // Если длина строки больше чем 20 символов, отрезаем часть строки
                if (nClientName.Length>20) {nClientName.PadLeft(20);}
                // Если имя пользователя короче, чем 20 символов, то остальные символы заполняем последовательностью, начиная с 20
                for (int i = 0; nClientName.Length < 20; i++) { nClientName = nClientName + Convert.ToChar(20 + i); }
                
                // Преобразуем строку в byte[]
                DataForSign = StrToByte(nClientName);


                // Вычисляем электронно-цифровую подпись для имени случайного клиента
                RetCode = GrdApi.GrdSign(
                            GrdHandle,  // Хэндл контейнера Guardant
                            03,         // Номер аппаратного алгоритма
                            20,         // Длина данных для вычисления ЭЦП (для ECC160 - 20 байт)
                            DataForSign,// Данные для ЭЦП
                            40,         // Длина цифровой подписи
                            out ECCSign);   // Переменная куда будет помещена электронно-цифровая подпись
                // Проверяем результат на возможные ошибки
                ErrorHandling(GrdHandle, RetCode); 
                //----------- Конец блока защиты -------- //
            }

            // включаем фильтр
            lFilter = true;
            this.BtnDisableFilter.Enabled = true;
            this.BtnEnableFilter.Enabled = false;
            this.reloadTable();
            conn.Close();
        }

        private void dataGridView1_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            // событие завершения редактирования поля в таблице
            // получаем код клиента
            string ID = this.dataGridView1.Rows[e.RowIndex].Cells[0].Value.ToString();
            string namefld = "";
            // получаем новый текст, введенный пользователем
            string newdata = this.dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value.ToString();
            // определяем какое поле менялось
            switch (e.ColumnIndex)
            {
                case 1:
                    namefld = "ClientName";
                    break;
                case 2:
                    namefld = "ClientAddress";
                    break;
                case 3:
                    namefld = "ClientTelNumber";
                    break;
                case 4:
                    namefld = "ClientComments";
                    break;
            }
            // если не смогли определить, то выходим
            if (namefld.Length == 0)
                return;
            OleDbConnection conn = new OleDbConnection(connectionString);
            conn.Open();
            // формируем запрос обновления данных в таблице БД
            OleDbCommand cmd = new OleDbCommand("UPDATE ClientsList SET ["+namefld+"] = '" + newdata + "' where [ClientId] = " + ID, conn);
            cmd.ExecuteNonQuery();
            conn.Close();
        }
        /* ------------------- Функция поиска по имени ---------------------------- */
        private void buttonFindName_Click(object sender, EventArgs e)
        { 
            
            string name = this.TBFindName.Text;
            if (name.Length > 0) // Если имя введено
            {


                #if (DEBUG) // Будем включать данный код, только в тестовую версию приложения
                
                /*  ----------- Начало блока Guardant API -------- */

                // -----------------------------------------------------------------
                // Пробуем считать обычной функцией чтения из памяти защищенной ячейки
                RetCode = GrdApi.GrdRead(GrdHandle,         // Хэндл контейнера
                                            024,            // Адрес памяти в ключе для начала считывания
                                            052,            // Размер блока данных для считывания
                                            out TempData);  // Переменная, куда будет помещен считанный блок
                ErrorHandling(GrdHandle, RetCode);

                // -----------------------------------------------------------------
                //Переключаемся на адресацию памяти SAM
                RetCode = GrdApi.GrdSetWorkMode(GrdHandle, GrdWM.SAM, GrdWMFM.DriverAuto);
                ErrorHandling(GrdHandle, RetCode);

                // -----------------------------------------------------------------
                // Чтение поля ID ключа              
                RetCode = GrdApi.GrdRead(GrdHandle, GrdSAM.dwID, out TempDataID);
                ErrorHandling(GrdHandle, RetCode);

                // Выводим номер ключа
                MessageBox.Show("Номер ключа: " + TempDataID.ToString(), "Тест функции GrdRead");

                /*  ----------- Конец блока Guardant API -------- */
                #endif



                OleDbConnection conn = new OleDbConnection(connectionString);
                conn.Open();
                // делаем запрос на получение идентификатора по первому совпадению текста в подстроке
                OleDbCommand cmd = new OleDbCommand("select [ClientID] from ClientsList where [ClientName] like '%" + name + "%'", conn);
                OleDbDataReader myOleDbDataReader = cmd.ExecuteReader();
                if (myOleDbDataReader.Read())
                {
                    // если нашли, то берем идентификатор 
                    string id = myOleDbDataReader[0].ToString();
                    // и перебирая все записи находим нужную
                    foreach(DataGridViewRow row in dataGridView1.Rows)
                    {
                        if (row.Cells[0].Value.ToString() == id)
                        {
                            // если нашли, то делаем ее текущей и выходим из цикла (зачем лишние движения?)
                            dataGridView1.CurrentCell = row.Cells[0];
                            break;
                        }
                    }
                } 
                else 
                {
                    MessageBox.Show("Запись по данному запросу не найдена", "Ошибка");
                }

                myOleDbDataReader.Close();
                conn.Close();
            }
        } // конец функции поиска по имени

        
        // Функция поиск по телефону (описание см. выше)
        private void buttonFindTel_Click(object sender, EventArgs e)
        {
            // Создание генератора случайных чисел
            Random rnd = new Random();
            // Создание подключения к БД, инициализация переменных
            OleDbConnection conn = new OleDbConnection(connectionString);
            conn.Open();
            OleDbCommand cmd = new OleDbCommand();
            OleDbDataReader myOleDbDataReader = null;

            string name = this.TBFindTel.Text;
            if (name.Length > 0)
            {

/*
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      Внимание! Данный пример является демонстрационным. Не стоит необдуманно использовать все предлагаемые методы.
      При разработке защиты обязательно учитывайте возможные сбои в работе реального приложения,
      такие как сбой БД, удаление части записей вручную и другие. Помните, что защита должна быть
      не только надежной, но и гибкой, устойчивой к любым сбоям самого приложения и его данных.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*/
         
/*  ----------- Начало блока Guardant API -------- */

            // В начале данного блока необходимо изменить маску ключа.
            // Запишите в ключ маску из файла "lesson1.nsd", делается
            // это с помощью программы GrdUtil.exe
            // Более подробно как это сделать можно прочитать в части 3 первого урока                

                // -----------------------------------------------------------------
                // Чтение данных из защищенной ячейки ключа защиты
                RetCode = GrdApi.GrdPI_Read(
                    GrdHandle,							// Хэндл контейнера Guardant
                    0,			                        // Номер защищенной ячейки 
                    0,									// Смещение с которого будет производиться чтение в защищенной ячейке
                    32,									// Количество байтов для чтения
                    out PIData,							// Указатель на буфер считанных данных
                    1469608341);			            // Пароль на чтение для защищенной ячейки
                
                // Если ячейка до сих пор не активирована. Первый запуск.
                if (RetCode == GrdE.InactiveItem)
                { // начало блока. ячейка не активирована

                    // -----------------------------------------------------------------
                    // Активация защищенной ячейки или алгоритма
                    RetCode = GrdApi.GrdPI_Activate(
                        GrdHandle,			 // Хэндл контейнера Guardant
                        0,				     // Номер защищенной ячейки или алгоритма
                        408956937);	         // Пароль для активации ячейки или алгоритма
                    ErrorHandling(GrdHandle, RetCode);

                    // -----------------------------------------------------------------
                    // Если активация проша успешно, производим чтение ячейки еще раз
                    RetCode = GrdApi.GrdPI_Read(
                        GrdHandle,							// Хэндл контейнера Guardant
                        0,			                        // Номер защищенной ячейки 
                        0,									// Смещение с которого будет производиться чтение в защищенной ячейке
                        32,									// Количество байтов для чтения
                        out PIData,							// Указатель на буфер считанных данных
                        1469608341);			            // Пароль на чтение для защищенной ячейки

                    ErrorHandling(GrdHandle, RetCode); // Проверяем корректность завершения функции чтения   

                    // Проверяем считанную ячейку. Есть ли там нет умолчального HelloWord!, выдаем ошибку
                    if (CheckHelloWord() == 0) {
                        MessageBox.Show("Обнаружено нарушение защиты", "Ошибка ключа защиты");
                        if (myOleDbDataReader != null) myOleDbDataReader.Close();
                        conn.Close();
                        Application.Exit();
                    };

                }   // конец блока. ячейка не активирована
                else
                { // начало блока. ячейка уже активирована
                    
                    ErrorHandling(GrdHandle, RetCode); // Проверяем корректность завершения функции чтения   

                    // Проверяем считанную ячейку. Есть ли она уже активирована, а там умолчальное HelloWord!, выдаем ошибку
                    if (CheckHelloWord() == 1) {
                        MessageBox.Show("Обнаружено нарушение защиты", "Ошибка ключа защиты");
                        if (myOleDbDataReader != null) myOleDbDataReader.Close();
                        conn.Close();
                        Application.Exit();
                    };
                    // Получаем номер клиента из защищенной ячейки
                    ClientID = PIData[3]+ PIData[2]*256 + PIData[1]*65536 + PIData[0]*16777216;

                    // Получаем имя клиента из защищенной ячейки
                    ClientName = "";
                    for (int i = 4; i < 33; i++)
                    {
                        if (PIData[i] == 0) break;
                        ClientName += (char)PIData[i];
                    }

                    // Проверяем существует ли клиент с данными полученными из защищенной ячейки в нашей Базе данных

                    cmd = new OleDbCommand("select TOP 1 [ClientID] from ClientsList where ([ClientID]=" + ClientID.ToString() +" AND [ClientName]='"+ClientName+"')", conn);
                    myOleDbDataReader = cmd.ExecuteReader();
                    bool ReadBool = myOleDbDataReader.Read(); // Записываем найдена ли ячейка

                    if (ReadBool) // Проверяем найдена ли ячейка?
                    { // Если найдена, то закрываем соединение с БД
                        //string ClientID = myOleDbDataReader[0].ToString();
                    }
                    else 
                    { // Если не найдена, выводим сообщение и закрываем программу
                        MessageBox.Show("Обнаружено нарушение защиты", "Ошибка ключа защиты");
                        if (myOleDbDataReader != null) myOleDbDataReader.Close();
                        conn.Close();
                        Application.Exit();                        
                    }

                } // конец блока. ячейка уже активирована

                /* ----------- Получаем запись из случайной ячейки БД и заносим ее в защищенную ячейку ----------------- */
                // Ищем самый максимальный ID
                cmd = new OleDbCommand("SELECT TOP 1 [ClientID] FROM ClientsList ORDER BY ClientID DESC", conn);
                myOleDbDataReader = cmd.ExecuteReader();
                if (myOleDbDataReader.Read())
                {
                    ClientID = Convert.ToInt32(myOleDbDataReader[0].ToString());
                }

                int randNum = rnd.Next(ClientID) + 1; // Делаем случайное число от максимального ID 

                // Выбираем случайную запись
                cmd = new OleDbCommand("SELECT TOP 1 [ClientID], [ClientName]  FROM ClientsList  WHERE [ClientID]>" + randNum.ToString(), conn);
                myOleDbDataReader = cmd.ExecuteReader();
                if (myOleDbDataReader.Read())
                {
                    ClientID = Convert.ToInt32(myOleDbDataReader[0].ToString());
                    ClientName = myOleDbDataReader[1].ToString();
                }
                        
               PIData[3] = Convert.ToByte(ClientID % 256); ClientID = ClientID / 256;
               PIData[2] = Convert.ToByte(ClientID % 256); ClientID = ClientID / 256;
               PIData[1] = Convert.ToByte(ClientID % 256); ClientID = ClientID / 256;
               PIData[0] = Convert.ToByte(ClientID);

                // Переносим строку в массив
               for (int i = 4; i < 32; i++)
               {
                   if (ClientName.Length>i-4) 
                   {
                       PIData[i] = Convert.ToByte(ClientName[i-4]);
                   } else {
                       PIData[i] = 0;
                   }
               }

               // -----------------------------------------------------------------
               // Запись данных в защищенную ячейку. 
               RetCode = GrdApi.GrdPI_Update(
                   GrdHandle,								// Хэндл контейнера 
                   0,				                        // Номер защищенной ячейки или алгоритма 
                   0,										// Смещение защищенной ячей
                   32,									    // Количество байтов для записи
                   PIData,							    // Указатель на буфер с данными
                   843783688,		                        //Пароль на запись, если нет то 0
                   GrdUM.MOV);						        // Метод обновления (MOV или XOR)
               ErrorHandling(GrdHandle, RetCode);
                       

/* ----------- Конец блока работы с Guardant API ------------------ */                

                // Поиск телефона по БД и переход к данной записи
                cmd = new OleDbCommand("select [ClientID] from ClientsList where [ClientTelNumber] like '%" + name + "%'", conn);
                myOleDbDataReader = cmd.ExecuteReader();
                if (myOleDbDataReader.Read())
                {
                    string id = myOleDbDataReader[0].ToString();
                    foreach (DataGridViewRow row in dataGridView1.Rows)
                    {
                        if (row.Cells[0].Value.ToString() == id)
                        {
                            dataGridView1.CurrentCell = row.Cells[0];
                            break;
                        }
                    }
                }
                else 
                {
                    MessageBox.Show("Запись по данному запросу не найдена", "Ошибка");
                }
            }

            // Завершаем работу с базой данных
            if (myOleDbDataReader != null ) myOleDbDataReader.Close();
            conn.Close();
        } // конец функции поиска по номеру телефона

        //----------------------------------------------------------------------------------------------
        //  Функция обработки ошибок
        //  Показывает результат, закрывает хэндл, и завершает работу программы
        //  Вход:  Хэндл контейнера Guardant 
        //	Вход :  код ошибки
        //	Выход: код ошибки
        //----------------------------------------------------------------------------------------------
        private static GrdE ErrorHandling(Handle hGrd, GrdE nRet)
        {
            if (nRet != GrdE.OK)
            {   

                // Выводим ошибку последней функции
                MessageBox.Show(GrdApi.PrintResult((int)nRet), "Ошибка");

                // Отключаемся от ключа защиты
                nRet = GrdApi.GrdLogout(hGrd);
                if (hGrd.Address != 0)	// Проверяем существует ли хэндл контейнера Guardant 
                {
                    // Закрываем хэндл, выходим с сервера ключа,  освобождаем память
                    nRet = GrdApi.GrdCloseHandle(hGrd);
                }
                // Деинициализация копии Guardant API. Метод GrdCleanup() обязательно должен быть вызван перед закрытием программы
                nRet = GrdApi.GrdCleanup();

                // Terminate application
                Environment.Exit((int)nRet);
            }
            return nRet;
        }

        // Проверка наличия HelloWord в массиве
        private int CheckHelloWord () 
        {
          // Проверяем считанную ячейку. Есть ли там умолчальное HelloWord!
          int i = 0; // Переменная цикла
                    string HelloWord = "HelloWord!";
                    while (i < 10)
                    { // длина "HelloWord!"
                        if (PIData[i] != HelloWord[i]) { break; } i++;
                    }

                    // Если HelloWord! отсутствует
                    if (i == 10) { return 1; } else { return 0; }
        }
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            /* ----------- Начало блока работы с Guardant API ------------------ */

            if (GrdHandle.Address != 0) // Проверяем был ли создан хэндл
            {
                // Закрывает сеанс работы с ключом
                RetCode = GrdApi.GrdLogout(GrdHandle);
                ErrorHandling(GrdHandle, RetCode);

                // Закрытие хэндла контейнера Guardant. Выход с сервера ключа и освобождение памяти
                RetCode = GrdApi.GrdCloseHandle(GrdHandle);
                ErrorHandling(GrdHandle, RetCode);
            }

            // -----------------------------------------------------------------
            // Деинициализация копии GrdAPI. 
            // Функция GrdCleanup() должна быть вызвана последней перед закрытием программы
            // -----------------------------------------------------------------
            RetCode = GrdApi.GrdCleanup();
            ErrorHandling(GrdHandle, RetCode);
            /* ----------- Конец блока работы с Guardant API ------------------ */
        }
 
        // Byte в Base64
        static public string EncodeTo64(byte[] toEncodeAsBytes)
        {
            string returnValue
                  = System.Convert.ToBase64String(toEncodeAsBytes);
            return returnValue;
        }

        // Base64 в byte
        static public byte[] DecodeFrom64(string encodedData)
        {
            byte[] encodedDataAsBytes
                = System.Convert.FromBase64String(encodedData);
            return encodedDataAsBytes;
        }
        // Строка в Byte
        static public byte[] StrToByte(string EncodeStr) 
        {
            byte[] returnValue
                = System.Text.ASCIIEncoding.ASCII.GetBytes(EncodeStr);
            return returnValue;
        }
        // Byte в строку
        static public string ByteToStr(byte[] EncodeByte) 
        {
            string returnValue =
                System.Text.ASCIIEncoding.ASCII.GetString(EncodeByte);
            return returnValue;
        }
        
        // Получение строки из Hex
        static public string ByteArrayToHexString(byte[] Bytes)  
        {  
            StringBuilder Result = new StringBuilder();  
            string HexAlphabet = "0123456789ABCDEF";  
            foreach (byte B in Bytes)  
            {
                Result.Append("0x");
                Result.Append(HexAlphabet[(int)(B >> 4)]);  
                Result.Append(HexAlphabet[(int)(B & 0xF)]);
                Result.Append(", ");
            }  
            return Result.ToString();  
        }

        private void BtnPurchaseAdd_Click(object sender, EventArgs e)
        {
            // Создаем и открываем форму добавления новой покупки текущему клиенту
            FormPurchaseAdd FPurchaseAdd = new FormPurchaseAdd();
            // Получаем ID и имя текущего клиента
            string CurClientID = this.dataGridView1.CurrentRow.Cells[0].Value.ToString();
            string CurClientName = this.dataGridView1.CurrentRow.Cells[1].Value.ToString();
            // Добавляем имя клиента на форуму и вызываем форуму
            FPurchaseAdd.LabelClientName.Text = CurClientName;
            DialogResult res = FPurchaseAdd.ShowDialog();
            // Если нажата кнопка "Добавить"
            
            if (FPurchaseAdd.PushBtnAdd)
            {
                DateTime DatePurchase = DateTime.Today;
                
                // Подключаемся к БД
                OleDbConnection conn = new OleDbConnection(this.connectionString);
                conn.Open();
                // Вставляем данные в БД
                string command = "INSERT INTO [Shopping] ([ClientID], [PurchaseDate], [PurchaseName]) " +
                    "VALUES ('" + CurClientID + "', '" + DatePurchase.ToString("dd.MM.yyyy") + "' ,'" + FPurchaseAdd.TBPurchaseName.Text + "')";
                OleDbCommand cmd = new OleDbCommand(command, conn);
                OleDbDataReader myOleDbDataReader = cmd.ExecuteReader();
                conn.Close();                 // Закрываем соединение с БД
            }
        }

        private void BtnPurchaseReport_Click(object sender, EventArgs e)
        {

            // Получаем ID и имя текущего клиента
            string CurClientID = this.dataGridView1.CurrentRow.Cells[0].Value.ToString();
            string CurClientName = this.dataGridView1.CurrentRow.Cells[1].Value.ToString();

            // Создаем форму отчета
            FormPurchaseReport FPurchaseReport = new FormPurchaseReport();
            FPurchaseReport.RTBPurchaseReport.Text = "Список покупок клиента: " + CurClientName + "\n\n";

            // Подключаемся к БД
            OleDbConnection conn = new OleDbConnection(this.connectionString);
            conn.Open();
            OleDbCommand cmd = new OleDbCommand("select * from Shopping where [ClientID]=" + CurClientID + " ORDER BY [PurchaseDate] ASC", conn);
            // выполняем запрос с получение объекта результирующей таблицы
            OleDbDataReader myOleDbDataReader = cmd.ExecuteReader();
            
            // Проверяем есть ли данные в выборке
            if (myOleDbDataReader.HasRows)
            {
                // Добавляем на страницу все покупки клиента
                while (myOleDbDataReader.Read())
                {
                    // Преобразуем строку в дату и форматируем при выводе
                    string DateStr = myOleDbDataReader["PurchaseDate"].ToString();
                    DateTime PurchaseDate = DateTime.Parse(DateStr);
                    FPurchaseReport.RTBPurchaseReport.Text += PurchaseDate.ToString("dd.MM.yyyy") + "  " + myOleDbDataReader["PurchaseName"].ToString() + "\n";
                }
            }
            else 
            {
                FPurchaseReport.RTBPurchaseReport.Text += "Данный клиент покупок не совершал"; 
            }

            conn.Close();                 // Закрываем соединение с БД
            // Отображаем диалог
            DialogResult res = FPurchaseReport.ShowDialog();
        }
        static void ProtectThread() 
        { 
            // Здесь будет программный код дополнительного потока для защиты приложения
            MessageBox.Show("Поток сработал", "Тест потока");
        }
    }
}
